; Image converter for 24-bit TGA to STe colour data
;
; Input
; * 24-bit uncompressed TGA
;
; Output
; * RAW STe colour data


x:		equ	1		;image width
y:		equ	250		;image height

size:		equ	x*y*2


		comment HEAD=%111

		opt	p=68030/68882

		output	.tos

start:
		move.w	#x,d0
		move.w	#y,d1
		lea	tga,a0
		lea	buf,a1
		bsr	convert
		bsr	save

		clr.w	-(sp)
		trap	#1
		

convert:
;Converts 24 bit uncompressed 24-bit TGA to STe colour data
;in	d0.w	x-res
;	d1.w	y-res
;	a0	tga source
;	a1	dest

		move.w	d0,.xc
		move.w	d1,.yc

		mulu	#3,d0
		subq.w	#1,d1
		mulu	d1,d0

		add.l	d0,a0

		lea	18(a0),a0		;skip header

		lea	.ste(pc),a2

		move.w	.yc,d7
		subq.w	#1,d7
.y:		move.w	.xc,d6
		subq.w	#1,d6
.x:

		moveq	#0,d0
		moveq	#0,d1

		move.b	(a0)+,d0
		lsr.b	#4,d0
		move.b	(a2,d0.w),d0
		move.b	d0,d1

		move.b	(a0)+,d0
		lsr.b	#4,d0
		move.b	(a2,d0.w),d0
		lsl.b	#4,d0
		or.b	d0,d1

		move.b	(a0)+,d0
		lsr.b	#4,d0
		move.b	(a2,d0.w),d0
		lsl.w	#8,d0
		or.w	d0,d1

		move.w	d1,(a1)+

		dbra	d6,.x
		move.w	.xc,d0
		mulu	#3*2,d0
		sub.w	d0,a0
		dbra	d7,.y

		rts
.ste:		dc.b	$0,$8,$1,$9,$2,$a,$3,$b,$4,$c,$5,$d,$6,$e,$7,$f
.xc:		dc.w	0
.yc:		dc.w	0


save:

		; fcreate()
		move.w	#0,-(sp)
		move.l	#filename,-(sp)
		move.w	#$3c,-(sp)
		trap	#1
		addq.l	#8,sp
		move.w	d0,filenum

		; fwrite()
		move.l	#buf,-(sp)
		move.l	filesize,-(sp)
		move.w	filenum,-(sp)
		move.w	#$40,-(sp)
		trap	#1
		lea.l	12(sp),sp

		; fclose()
		move.w	filenum,-(sp)
		move.w	#$3e,-(sp)
		trap	#1
		addq.l	#4,sp
		rts


		section	data


tga:		incbin	'rasters.tga'
		even

		
filesize:	dc.l	size

filename:	dc.b	'rasters.12b',0
		even
 

		section	bss

buf:		ds.b	size
filenum:	ds.w	1

		even


		section	text
